//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXGdiBitmap.cpp
 * @brief		HBITMAPNXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2010 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define _IRIS_WXGdiBitmap_CPP_

//======================================================================
// include
#include "WXGdiBitmap.h"

namespace iris {
namespace wx
{

//======================================================================
// class

/**********************************************************************//**
 *
 * rbg}bv̍쐬
 *
 -----------------------------------------------------------------------
 * @param [in]	nWidth		= 
 * @param [in]	nHeight		= 
 * @param [in]	uPlanes		= J[v[
 * @param [in]	nBitCount	= rbg[x
 * @param [in]	lpBits		= sNZf[^
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::Create(int nWidth, int nHeight, UINT uPlanes, UINT nBitCount, const void* lpBits)
{
	HBITMAP hBmp = CreateBitmap(nWidth, nHeight, uPlanes, nBitCount, lpBits);
	if( hBmp == nullptr ) return FALSE;
	if( !Attach(hBmp) )
	{
		DeleteObject(hBmp);
		return FALSE;
	}
	return TRUE;
}

/**********************************************************************//**
 *
 * rbg}bv̍쐬
 *
 -----------------------------------------------------------------------
 * @param [in]	lpbmp		= rbg}bv
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::CreateIndirect(const LPBITMAP lpbmp)
{
	HBITMAP hBmp = CreateBitmapIndirect(lpbmp);
	if( hBmp == nullptr ) return FALSE;
	if( !Attach(hBmp) )
	{
		DeleteObject(hBmp);
		return FALSE;
	}
	return TRUE;
}

/**********************************************************************//**
 *
 * rbg}bv̍쐬
 *
 -----------------------------------------------------------------------
 * @param [in]	hdc		= foCXReLXg
 * @param [in]	lpbih	= rbg}bṽf[^
 * @param [in]	dwInit	= IvV
 * @param [in]	pjBits	= f[^
 * @param [in]	lpbmi	= rbg}bv
 * @param [in]	Usage	= F̎gp@B(DIB_***)
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::CreateDIB(HDC hdc, const LPBITMAPINFOHEADER lpbih, DWORD dwInit, const void* pjBits, const LPBITMAPINFO lpbmi, UINT Usage)
{
	HBITMAP hBmp = CreateDIBitmap(hdc, lpbih, dwInit, pjBits, lpbmi, Usage);
	if( hBmp == nullptr ) return FALSE;
	if( !Attach(hBmp) )
	{
		DeleteObject(hBmp);
		return FALSE;
	}
	return TRUE;
}

/**********************************************************************//**
 *
 * rbg}bv̍쐬
 *
 -----------------------------------------------------------------------
 * @param [in]	hdc			= foCXReLXg
 * @param [in]	lpbmi		= rbg}bv
 * @param [in]	Usage		= F̎gp@B(DIB_***)
 * @param [out]	ppvBits		= óBDIBrbgl
 * @param [in]	hSection	= t@C}bsOIuWFNg(nullptr)
 * @param [in]	offset		= t@C}bsOIuWFNg̃ItZbg
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::CreateDIBSection(HDC hdc, const LPBITMAPINFO lpbmi, UINT Usage, void** ppvBits, HANDLE hSection, DWORD offset)
{
	HBITMAP hBmp = ::CreateDIBSection(hdc, lpbmi, Usage, ppvBits, hSection, offset);
	if( hBmp == nullptr ) return FALSE;
	if( !Attach(hBmp) )
	{
		DeleteObject(hBmp);
		return FALSE;
	}
	return TRUE;
}

/**********************************************************************//**
 *
 * rbg}bv̓ǂݍ
 *
 -----------------------------------------------------------------------
 * @param [in]	hInstance		= CX^Xnh
 * @param [in]	lpBitmapName	= rbg}bv
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::Load (HINSTANCE hInstance, LPCTSTR lpBitmapName)
{
#ifdef UNICODE
	return LoadW(hInstance, lpBitmapName);
#else
	return LoadA(hInstance, lpBitmapName);
#endif
}
/// CGDIBitmap::Load Q
BOOL CGDIBitmap::LoadA(HINSTANCE hInstance, LPCSTR  lpBitmapName)
{
	HBITMAP hBmp = ::LoadBitmapA(hInstance, lpBitmapName);
	if( !Attach(hBmp) )
	{
		DeleteObject(hBmp);
		return FALSE;
	}
	return TRUE;
}
/// CGDIBitmap::Load Q
BOOL CGDIBitmap::LoadW(HINSTANCE hInstance, LPCWSTR lpBitmapName)
{
	HBITMAP hBmp = ::LoadBitmapW(hInstance, lpBitmapName);
	if( !Attach(hBmp) )
	{
		DeleteObject(hBmp);
		return FALSE;
	}
	return TRUE;
}

/**********************************************************************//**
 *
 * foCXReLXgɊ֘AtĂrbg}bv̍쐬
 *
 -----------------------------------------------------------------------
 * @param [in]	hdc		= foCXReLXg
 * @param [in]	cx		= 
 * @param [in]	cy		= 
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::CreateCompatible(HDC hdc, int cx, int cy)
{
	HBITMAP hBmp = CreateCompatibleBitmap(hdc, cx, cy);
	if( !Attach(hBmp) )
	{
		DeleteObject(hBmp);
		return FALSE;
	}
	return TRUE;
}

/**********************************************************************//**
 *
 * f[^̕ύX
 *
 -----------------------------------------------------------------------
 * @param [in]	hdc			= foCXReLXg
 * @param [in]	uStart		= ύX̊JnC
 * @param [in]	uLines		= ύX郉C
 * @param [in]	lpBits		= rbg
 * @param [in]	lpbmi		= rbg}bv
 * @param [in]	ColorUse	= J[CfbNX̎
 * @return	
*//***********************************************************************/
int CGDIBitmap::SetDIBits(HDC hdc, UINT uStart, UINT uLines, const void* lpBits, const LPBITMAPINFO lpbmi, UINT ColorUse)
{
	return ::SetDIBits(hdc, m_hObj, uStart, uLines, lpBits, lpbmi, ColorUse);
}

/**********************************************************************//**
 *
 * f[^̎擾
 *
 -----------------------------------------------------------------------
 * @param [in]	hdc			= foCXReLXg
 * @param [in]	uStart		= ύX̊JnC
 * @param [in]	uLines		= ύX郉C
 * @param [out]	lpBits		= rbg
 * @param [out]	lpbmi		= rbg}bv
 * @param [in]	Usage		= F̎gp@B(DIB_***)
 * @return	
*//***********************************************************************/
int CGDIBitmap::GetDIBits(HDC hdc, UINT uStart, UINT uLines, LPVOID lpBits, LPBITMAPINFO lpbmi, UINT Usage)
{
	return ::GetDIBits(hdc, m_hObj, uStart, uLines, lpBits, lpbmi, Usage);
}

/**********************************************************************//**
 *
 * rbg}bṽTCY擾
 *
 * @note	擾Ώۂ̃TCÝA SetDimensionEx ֐gĐݒ肵̂łȂ΂Ȃ܂
 *
 -----------------------------------------------------------------------
 * @param [out]	lpSize		= o
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::GetDimensionEx(LPSIZE lpSize)
{
	return GetBitmapDimensionEx(m_hObj, lpSize);
}

/**********************************************************************//**
 *
 * rbg}bṽTCYݒ
 *
 -----------------------------------------------------------------------
 * @param [in]	nWidth	= (0.01mmP)
 * @param [in]	nHeight	= (0.01mmP)
 * @param [out]	lpSize	= ̃TCY(nullptr)
 * @return	
*//***********************************************************************/
BOOL CGDIBitmap::SetDimensionEx(int nWidth, int nHeight, LPSIZE lpSize)
{
	return SetBitmapDimensionEx(m_hObj, nWidth, nHeight, lpSize);
}

}	// end of namespace wx
}	// end of namespace iris
