//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXGdiStockObject.h
 * @brief		GDIStockIuWFNgt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2010 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#ifndef _IRIS_WXGdiStockObject_H_
#define _IRIS_WXGdiStockObject_H_

//======================================================================
// include
#include "WXGDIObject.h"
#include <windowsx.h>

namespace iris {
namespace wx
{

//======================================================================
// class
//! StockIuWFNgNX
template<typename _TN>
class CGDIStockObject : public CGDIObjectBase<_TN>
{
public:
	/// RXgN^
	CGDIStockObject(void)	{}
	/// RXgN^
	CGDIStockObject(int nObject) { GetStockObject(nObject); }
	/// fXgN^
	~CGDIStockObject(void)	{}
	
public:
	/// StockIuWFNg̎擾
	_MyObj	GetStockObject(int nObject)
	{
		_MyObj hObj = static_cast<_MyObj>(::GetStockObject(nObject));
		Detach();
		Attach(hObj);
		return hObj;
	}
};

}	// end of namespace wx
}	// end of namespace iris

#endif
