//======================================================================
//-----------------------------------------------------------------------
/**
 * @file		WXProcess.cpp
 * @brief		vZXNXt@C
 *
 * @author		t.sirayanagi
 * @version		1.0
 *
 * @par			copyright
 * Copyright (C) 2009-2010 Takazumi Shirayanagi\n
 * The new BSD License is applied to this software.
 * see iris_LICENSE.txt
*/
//-----------------------------------------------------------------------
//======================================================================
#define _IRIS_WXProcess_CPP_

//======================================================================
// include
#include "WXProcess.h"
#include "iris_debug.h"

namespace iris {
namespace wx
{

//======================================================================
// class
/**********************************************************************//**
 *
 * RXgN^
 * 
*//***********************************************************************/
CProcess::CProcess(void)
{
}

/**********************************************************************//**
 *
 * RXgN^
 * 
 ----------------------------------------------------------------------
 * @param [in]	hProcess	= ֘AtvZX
*//***********************************************************************/
CProcess::CProcess(HANDLE hProcess)
: CHandle(hProcess)
{
}

/**********************************************************************//**
 *
 * fXgN^
 * 
*//***********************************************************************/
CProcess::~CProcess(void)
{
}

/**********************************************************************//**
 *
 * 쐬
 * 
 ----------------------------------------------------------------------
 * @param [in]	lpApplicationName	= s\t@C
 * @param [in]	lpCmdLine			= R}hC
 * @param [in]	lpProcessAttr		= vZX̃ZLeBLqq
 * @param [in]	lpThreadAttr		= Xbh̃ZLeBLqq
 * @param [in]	bInheritHandles		= nȟpIvV
 * @param [in]	dwCreationFlags		= 쐬tO(CREATE_*** etc...)
 * @param [in]	lpEnvironment		= VubN
 * @param [in]	lpCurrentDirectory	= ƃfBNg
 * @param [in]	lpStartupInfo		= Jnp[^
 * @param [out]	lppi				= vZXo
 * @return	
*//***********************************************************************/
BOOL CProcess::Create (LPCTSTR lpApplicationName, LPTSTR lpCmdLine
					   , LPSECURITY_ATTRIBUTES lpProcessAttr, LPSECURITY_ATTRIBUTES lpThreadAttr
					   , BOOL bInheritHandles, DWORD dwCreationFlags
					   , LPVOID lpEnvironment, LPCTSTR lpCurrentDirectory
					   , LPSTARTUPINFO lpStartupInfo, LPPROCESS_INFORMATION lppi)
{
	PROCESS_INFORMATION pi;
	if( !::CreateProcess (lpApplicationName, lpCmdLine, lpProcessAttr, lpThreadAttr
							, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory
							, lpStartupInfo, &pi) )
	{
		return FALSE;
	}
	return _Create(lppi, &pi);
}
/// CProcess::Create Q
BOOL CProcess::CreateA(LPCSTR  lpApplicationName, LPSTR  lpCmdLine
					   , LPSECURITY_ATTRIBUTES lpProcessAttr, LPSECURITY_ATTRIBUTES lpThreadAttr
					   , BOOL bInheritHandles, DWORD dwCreationFlags
					   , LPVOID lpEnvironment, LPCSTR  lpCurrentDirectory
					   , LPSTARTUPINFOA lpStartupInfo, LPPROCESS_INFORMATION lppi)
{
	PROCESS_INFORMATION pi;
	if( !::CreateProcessA(lpApplicationName, lpCmdLine, lpProcessAttr, lpThreadAttr
							, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory
							, lpStartupInfo, &pi) )
	{
		return FALSE;
	}
	return _Create(lppi, &pi);
}
/// CProcess::Create Q
BOOL CProcess::CreateW(LPCWSTR lpApplicationName, LPWSTR lpCmdLine
					   , LPSECURITY_ATTRIBUTES lpProcessAttr, LPSECURITY_ATTRIBUTES lpThreadAttr
					   , BOOL bInheritHandles, DWORD dwCreationFlags
					   , LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory
					   , LPSTARTUPINFOW lpStartupInfo, LPPROCESS_INFORMATION lppi)
{
	PROCESS_INFORMATION pi;
	if( !::CreateProcessW(lpApplicationName, lpCmdLine, lpProcessAttr, lpThreadAttr
							, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory
							, lpStartupInfo, &pi) )
	{
		return FALSE;
	}
	return _Create(lppi, &pi);
}

/**********************************************************************//**
 *
 * 쐬
 * 
 ----------------------------------------------------------------------
 * @param [in]	hToken				= OIĂ郆[U[\g[Nnh
 * @param [in]	lpApplicationName	= s\t@C
 * @param [in]	lpCmdLine			= R}hC
 * @param [in]	lpProcessAttr		= vZX̃ZLeBLqq
 * @param [in]	lpThreadAttr		= Xbh̃ZLeBLqq
 * @param [in]	bInheritHandles		= nȟpIvV
 * @param [in]	dwCreationFlags		= 쐬tO(CREATE_*** etc...)
 * @param [in]	lpEnvironment		= VubN
 * @param [in]	lpCurrentDirectory	= ƃfBNg
 * @param [in]	lpStartupInfo		= Jnp[^
 * @param [out]	lppi				= vZXo
 * @return	
*//***********************************************************************/
BOOL CProcess::CreateAsUser (HANDLE hToken, LPCTSTR lpApplicationName, LPTSTR lpCmdLine
					   , LPSECURITY_ATTRIBUTES lpProcessAttr, LPSECURITY_ATTRIBUTES lpThreadAttr
					   , BOOL bInheritHandles, DWORD dwCreationFlags
					   , LPVOID lpEnvironment, LPCTSTR lpCurrentDirectory
					   , LPSTARTUPINFO lpStartupInfo, LPPROCESS_INFORMATION lppi)
{
	PROCESS_INFORMATION pi;
	if( !CreateProcessAsUser (hToken, lpApplicationName, lpCmdLine, lpProcessAttr, lpThreadAttr
							, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory
							, lpStartupInfo, &pi) )
	{
		return FALSE;
	}
	return _Create(lppi, &pi);
}
/// CProcess::CreateAsUser Q
BOOL CProcess::CreateAsUserA(HANDLE hToken, LPCSTR  lpApplicationName, LPSTR  lpCmdLine
					   , LPSECURITY_ATTRIBUTES lpProcessAttr, LPSECURITY_ATTRIBUTES lpThreadAttr
					   , BOOL bInheritHandles, DWORD dwCreationFlags
					   , LPVOID lpEnvironment, LPCSTR  lpCurrentDirectory
					   , LPSTARTUPINFOA lpStartupInfo, LPPROCESS_INFORMATION lppi)
{
	PROCESS_INFORMATION pi;
	if( !CreateProcessAsUserA(hToken, lpApplicationName, lpCmdLine, lpProcessAttr, lpThreadAttr
							, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory
							, lpStartupInfo, &pi) )
	{
		return FALSE;
	}
	return _Create(lppi, &pi);
}
/// CProcess::CreateAsUser Q
BOOL CProcess::CreateAsUserW(HANDLE hToken, LPCWSTR lpApplicationName, LPWSTR lpCmdLine
					   , LPSECURITY_ATTRIBUTES lpProcessAttr, LPSECURITY_ATTRIBUTES lpThreadAttr
					   , BOOL bInheritHandles, DWORD dwCreationFlags
					   , LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory
					   , LPSTARTUPINFOW lpStartupInfo, LPPROCESS_INFORMATION lppi)
{
	PROCESS_INFORMATION pi;
	if( !CreateProcessAsUserW(hToken, lpApplicationName, lpCmdLine, lpProcessAttr, lpThreadAttr
							, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory
							, lpStartupInfo, &pi) )
	{
		return FALSE;
	}
	return _Create(lppi, &pi);
}

/**********************************************************************//**
 *
 * vZX̏IR[h̎擾
 * 
 ----------------------------------------------------------------------
 * @return	IR[h
*//***********************************************************************/
DWORD CProcess::GetExitCode(void)
{
	DWORD dwCode = 0;
	GetExitCodeProcess(m_hObject, &dwCode);
	return dwCode;
}

/**********************************************************************//**
 *
 * vZXID̎擾
 * 
 ----------------------------------------------------------------------
 * @return	vZXID
*//***********************************************************************/
DWORD CProcess::GetProcessId(void)
{
	return ::GetProcessId(m_hObject);
}

/**********************************************************************//**
 *
 * vZX̎ԏ̎擾
 * 
 ----------------------------------------------------------------------
 * @param [out]	lpCreationTime	= vZX̍쐬
 * @param [out]	lpExitTime		= vZX̏I
 * @param [out]	lpKernelTime	= vZX̃J[l[hł̌oߎ
 * @param [out]	lpUserTime		= vZX̃[U[[hł̌oߎ
 * @return	
*//***********************************************************************/
BOOL CProcess::GetProcessTimes(LPFILETIME lpCreationTime, LPFILETIME lpExitTime, LPFILETIME lpKernelTime, LPFILETIME lpUserTime)
{
	return ::GetProcessTimes(m_hObject, lpCreationTime, lpExitTime, lpKernelTime, lpUserTime);
}

/**********************************************************************//**
 *
 * vZX̃J[l[hł̌oߎԂ擾
 * 
 ----------------------------------------------------------------------
 * @param [out]	lpKernelTime	= vZX̃J[l[hł̌oߎ
 * @return	
*//***********************************************************************/
BOOL CProcess::GetProcessKernelTime(LPFILETIME lpKernelTime)
{
	return ::GetProcessTimes(m_hObject, nullptr, nullptr, lpKernelTime, nullptr);
}

/**********************************************************************//**
 *
 * J
 * 
 ----------------------------------------------------------------------
 * @param [in]	dwDesiredAccess	= 
 * @param [in]	bInheritHandle	= 
 * @param [in]	dwProcessId		= vZXID
 * @return	
*//***********************************************************************/
BOOL CProcess::Open(DWORD dwDesiredAccess, BOOL bInheritHandle, DWORD dwProcessId)
{
	HANDLE hProcess = ::OpenProcess(dwDesiredAccess, bInheritHandle, dwProcessId);
	if( hProcess == nullptr ) return FALSE;
	if( !Attach(hProcess) )
	{
		::CloseHandle(hProcess);
		return FALSE;
	}
	return TRUE;
}

/**********************************************************************//**
 *
 * J
 * 
 ----------------------------------------------------------------------
 * @param [out]	lppid	= vZXo
 * @param [in]	lppis	= vZX
 * @return	
*//***********************************************************************/
BOOL CProcess::_Create(LPPROCESS_INFORMATION lppid, LPPROCESS_INFORMATION lppis)
{
	IRIS_ASSERT( lppis != nullptr );
	if( lppid != nullptr ) 
	{
		*lppid = *lppis;
		Attach(lppis->hProcess);	// lppid ɏo͂ł̂ŁA֘AtsĂOKƂ
	}
	else
	{
		::CloseHandle(lppis->hThread);
		if( !Attach(lppis->hProcess) )
		{
			::CloseHandle(lppis->hProcess);
			return FALSE;
		}
	}
	return TRUE;
}

// CProcessInfo
/**********************************************************************//**
 *
 * fXgN^
 * 
*//***********************************************************************/
CProcessInfo::~CProcessInfo(void)
{
	if( m_Info.hProcess != nullptr )
	{
		CloseHandle(m_Info.hProcess);
		m_Info.hProcess = nullptr;
	}
	if( m_Info.hThread != nullptr )
	{
		CloseHandle(m_Info.hThread);
		m_Info.hProcess = nullptr;
	}
}


}	// end of namespace wx
}	// end of namespace iris

